function [fv,p,mx,Cx,Cy,b]=CWMScaleFocus(y,x,Nc,iter,optim,Sigmax)
% EM ALGORITHM
% Los regresores locales son lineales
%
% Este programa admite una dimension indefinida en x y en y


Dy=size(y,1); % Dimension de y
Nf=size(x,1); % Dimension de x
Nt=size(x,2); % Cantidad de datos
Nc; % Numero de clusters

Sig=ones(1,Nc);

f1=figure;
set(gcf,'position',[6   500   560   220]);

Lk=0;

Lopt=10^100;
for opt=1:optim
   p=ones(Nc,1)/Nc; % p(Ci)
   
   gx=zeros(Nt,1);
   gy=zeros(Nt,1);
   h=zeros(Nt,Nc);
   b=zeros(Dy,Nf+1,Nc);
   
   sigmay=cov(y');
   sigmax=cov(x');
   max(sigmax(:))
   %if Dy==1
   MAXy=max(y(2,:)); MINy=min(y(2,:));
   mc=linspace(MINy,MAXy,Nc+2); mc=mc(2:Nc+1);
   mc=linspace(MINy,MAXy,Nc); %mc=mc(2:Nc+1);
   %mc=linspace(-5,5,Nc); mc=mc(1:Nc);
   b(1,1,:)=mc+0*(rand(size(mc))-.5)*(MAXy-MINy)/Nc/2;
   %du=mc;
   for i=1:Nc
      [m,n]=min(abs(y(1,:)-mc(i)));
      k(i)=n;
   end
   %else
   %   MAXy=max(y(1,:)); MINy=min(y(1,:));
   %   mc=linspace(MINy,MAXy,Nc); mc=mc(1:Nc);
   k=fix(rand(1,Nc)*Nt)+1;
   %end
   cx=mean(x,2);
   for i=1:Nc
      mx(:,i)=x(:,k(i));
      b(:,1,i)=y(:,k(i));
      du(:,i)=y(:,k(i));
      Cx(:,:,i)=.5*diag(diag(sigmax))/Nc^(1/Nf)+.5*eye(Nf,Nf)*max(sigmax(:))/Nc;
      Cy(:,:,i)=1*sigmay/Nc;
   end
      %du=mc;

   % E STEP:
   ss=0;
   
   %%%%%% Calulo de P(Cj|y,x)  -> h
   for j=1:Nc
      % Calculo de P(x,y|Cj)=P(y|x,Cj)*P(x|Cj)
      % P(x|Cj):
      xmx=x-repmat(mx(:,j),1,Nt);
      iXa=inv(Cx(:,:,j));
      xmX=iXa'*xmx;
      dxm=sum(xmX.*xmx)';
      % P(y|x,Cj):
      ym=y-b(:,:,j)*[ones(1,Nt); xmx];
      if Dy>1
         iXa=inv(Cy(:,:,j));
         ymY=ym'*iXa;
         dym=dot(ymY',ym)';
      else
         dym=ym'.^2/Cy(:,:,j);
      end
      
      gxy=exp(-0.5*(dym+dxm))/sqrt(det(Cy(:,:,j)))/(2*pi)^(Dy/2)/sqrt(det(Cx(:,:,j)))/(2*pi)^(Nf/2);
      gx(:,j)=exp(-0.5*(dxm))/sqrt(det(Cx(:,:,j)))/(2*pi)^(Nf/2);
      % P(y,x):
      h(:,j)=real(p(j)*gxy);
      ss=ss+h(:,j);
   end
   
   % E-M algorithm
   for k=1:iter  
      disp(k)
      figure(f1)
      subplot(231)
      cla
      plot(x(1,:),x(2,:),'y.')
      hold on
      plot(mx(1,:),mx(2,:),'+')
      axis('square')
      axis([min(x(1,:)) max(x(1,:)) min(x(2,:)) max(x(2,:))])
      drawnow
      subplot(232)
      cla
      %plot(y(1,:),x(1,:),'.')
      hold on
      my=b(:,1,:);
      plot(my(1,:),mx(1,:),'+')
      axis('square')
      title('output')
      axis([min(y(1,:)) max(y(1,:)) min(x(1,:)) max(x(1,:))])
      drawnow
            
      if Dy>1
         subplot(233)
         cla
         %plot(y(1,:),y(2,:),'.')
         hold on
         my=b(:,1,:);
         plot(my(1,:),my(2,:),'+')
         axis('square')
         title('output')
         axis([min(y(1,:)) max(y(1,:)) min(y(2,:)) max(y(2,:))])
         drawnow
         if Dy>2
            subplot(133)
            cla
            plot(y(3,:),y(2,:),'y.')
            hold on
            my=b(:,1,:);
            plot(my(3,:),my(2,:),'+')
            axis([min(y(3,:)) max(y(3,:)) min(y(2,:)) max(y(2,:))])
            axis('square')
            title('output')
            drawnow
         end
      end
      
      %figure(f1+1)
      %for j=1:Nc
      %   subplot(Nc,1,j)
      %   plot(h(:,j))
      %end
      for j=1:Nc
         h(:,j)=h(:,j)./(ss);
      end
      tic
      
      my=1:Nc;
      my(:)=b(1,1,:);
      subplot(234)
      stem(my,p,'+')
      axis('square')
      
      [r,Cluster]=max(h,[],2);
      N=hist(Cluster,1:Nc);
      [r,Clustergx]=max(gx,[],2);
      Ngx=hist(Clustergx,1:Nc);
      subplot(235)
      stem(my,N,'o')
      axis('square')
      drawnow
      
      Nmean=length(Cluster);
      plast=p;
      %for j=1:Nc
      %   Ncl=sum(Clustergx==j);
      %   p(j)=plast(j)/((1+Ncl)/(Nmean/Nc));
      %   Sig(j)=Sig(j)*(1000+Nmean/Nc)/(1000+Ncl);
      %end
      subplot(236)
      stem(my,Ngx,'o')
      axis('square')
      %subplot(233)
      %stem(my,Sig,'o')
      %axis('square')
      drawnow
      p=p/sum(p);
      
      ss=0;
      SUMtot=sum(h(:));
      shj=sum(h);
      Cxm=0;
      for j=1:Nc
         sh=shj(j);
         p(j)=sh/SUMtot;
         Cxm=Cxm+Cx(:,:,j)*p(j);
      end
      for j=1:Nc
         % M-STEP   
         sh=shj(j);
         p(j)=sh/SUMtot;
         %p(j)=1/Nc; % !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         
         hDy=repmat(h(:,j)',Dy,1);
         hNf=repmat(h(:,j)',Nf,1);
         mx(:,j)=sum(hNf.*x,2)/sh;
         
         my=sum(hDy.*y,2)/sh;
         %my=du(:,j);
         %my(2)=mc(j); 
         %my(1)=64;
         
         xmx=x-repmat(mx(:,j),1,Nt);
         xmxp=xmx';
         X=(hNf.*xmx)*xmxp/sh;
         Cx(:,:,j)=X+Sigmax*eye(Nf,Nf)/Nc^(1/Nf)*mean(diag(sigmax));
         iXa=inv(Cx(:,:,j));
         
         % Calculo de b
         Bm=zeros(Nf+1,Nf+1); Bm(1,1)=1;
         Bm(2:Nf+1,2:Nf+1)=iXa;
         yxm=(hDy.*y)*xmxp/sh;
         Am=[my yxm];
         b(:,:,j)=Am*Bm';
                  
         %calculo de Cy
         ym=y-b(:,:,j)*[ones(1,Nt); xmx];
         if Dy>1
            %Cy(:,:,j)=(hDy.*ym)*ym'/sh+0.4*diag([10000/1 100/8].^2);
            Cy(:,:,j)=(hDy.*ym)*ym'/sh+0.4*diag([10000/1 100/6].^2);
            %Cy(:,:,j)=(hDy.*ym)*ym'/sh+0.1*diag([100/1 100/4].^2);
         else
            Cy(:,:,j)=(hDy.*ym)*ym'/sh+0.1*diag([100/4].^2);
         end
         
         % STAGE E:
         iXa=inv(Cxm);
         xmX=iXa'*xmx;
         dxm=sum(xmX.*xmx);
         % P(y|x,Cj):
         if Dy>1
            iXa=inv(Cy(:,:,j));
            ymY=iXa'*ym;
            dym=dot(ymY,ym);
         else
            dym=ym.*ym/Cy(:,:,j);
         end
         
         gxy=exp(-0.5*(dym+dxm))/sqrt(det(Cy(:,:,j)))/(2*pi)^(Dy/2+Nf/2)*sqrt(det(iXa));
         gx(:,j)=exp(-0.5*(dxm'))*sqrt(det(iXa))/(2*pi)^(Nf/2);
         % P(y,x):
         h(:,j)=p(j)*gxy';
         ss=ss+h(:,j);
      end
      toc
         
         % LIKELIHOOD de los datos observados:
      L=-sum(log(ss));
      Lk(k,opt)=L;
   end
   
   %if L<Lopt
      p_opt=p;
      mx_opt=mx;
      Cx_opt=Cx;
      Cy_opt=Cy;
      b_opt=b;
      Lopt=L;
   %end
   
end
p=p_opt;
mx=mx_opt;
Cx=Cx_opt;
Cy=Cy_opt;
b=b_opt;

%Cxm=0;
%for j=1:Nc
%   Cxm=Cxm+Cx(:,:,j)*p(j);
%end
%for j=1:Nc
%   Cx(:,:,j)=Cxm;
%end

fv=Lopt;

close

