function [fv,gx,gy]=FyCWM(y,x,p,mx,Cx,Cy,b)
% evaluar la densidad de probabilidad f(y|x)
%

Dy=size(y,1); % Dimension de y
Nf=size(x,1); % Dimension de x
Nt=size(y,2); % Cantidad de datos
Nc=length(p);

gx=zeros(1,Nc);
gy=zeros(Nt,Nc);

% ART
fv=0;
%%%%%% Calulo de P(Cj|y,x)  -> h
for j=1:Nc
    % Calculo de P(x,y|Cj)=P(y|x,Cj)*P(x|Cj)
    % P(x|Cj):
    xm=x-mx(:,j);
    iXa=inv(Cx(:,:,j));
    xmX=iXa'*xm;
    dxm=dot(xmX,xm)';

    gx(j)=exp(-0.5*dxm)/sqrt(det(Cx(:,:,j)))/(2*pi)^(Nf/2);
    % P(y|x,Cj):
    ym=y-repmat(b(:,:,j)*[1; xm],1,Nt);
    if Dy>1
        iXa=inv(Cy(:,:,j));
        ymY=iXa'*ym;
        dym=dot(ymY,ym)';
    else
        dym=ym'.^2/Cy(:,:,j);
    end
    gy(:,j)=exp(-0.5*dym)/sqrt(det(Cy(:,:,j)))/(2*pi)^(Dy/2);
    % P(y,x):
    fv=fv+p(j)*gx(j).*gy(:,j);
end
gx=real(gx);
gy=real(gy);
fv=real(fv);
