function [focus, Th, th] = foa_MultiRes(img, fileParameters);
%
% Compute context-driven focus of attention.
% [f, Th, th] = foa(img, fileParameters);

load(fileParameters)

[nrows, ncols, c] = size(img);

if (nrows ~= desiredHeight)
%     disp('Attention, image aspect ratio might have changed')
%     size(img)
%     [desiredHeight desiredWidth]
    img = imresize(img, [desiredHeight desiredWidth], 'bilinear');
end

% Compute global features
[vL, vLind, vG] = features(img, Nsc, Nor, Nb);
vG = pc'*vG;

% Compute focus of attention = p(x,y|Vg)
ux=1:8:desiredHeight;
[xx, yy]=meshgrid(ux,ux);
Sxy = [xx(:) yy(:)]';
fdtF = FyCWM(Sxy, vG(1:np), pF, mxF,CxF,CyF, bF);

Pp = reshape(fdtF, size(xx));
Pxo = imresize(Pp,[nrows, ncols], 'bilinear');
focus = Pxo/max(Pxo(:)); 
