function [focus, Th, th] = foa_multiRes(img, fileParameters, whichRes);

% Compute context-driven focus of attention.
% [f, Th, th] = foa(img, fileParameters);

if nargin < 3; whichRes = 4; end

load(fileParameters)

[nrows, ncols, c] = size(img);

if (nrows ~= desiredHeight)
%     disp('Attention, image aspect ratio might have changed')
%     size(img)
%     [desiredHeight desiredWidth]
    img = imresize(img, [desiredHeight desiredWidth], 'bilinear');
end

% Compute global features
% [vL_Nb2, vLind_Nb2, vG_Nb2] = features(img, Nsc, Nor, Nb);
% vG = pc'*vG;

for i = 1:length(whichRes)
    Nb = whichRes(i);
    [vL{i}, vLind{i}, vG_eaRes{i}] = features(img, Nsc, Nor, Nb);
end
vG = cat(1,vG_eaRes{:});
vG = pc'*vG;

% Compute focus of attention = p(x,y|Vg)
ux=1:8:desiredHeight;
[xx, yy]=meshgrid(ux,ux);
Sxy = [xx(:) yy(:)]';
fdtF = FyCWM(Sxy, vG(1:np), pF, mxF,CxF,CyF, bF);

Pp = reshape(fdtF, size(xx));
Pxo = imresize(Pp,[nrows, ncols], 'bilinear');
focus = Pxo/max(Pxo(:)); 
