function [vL, vLind, vC, vColor]=features(img, Nsc, Nor, Nb)
% img 
%
% Nsc = number of scales
% Nor = number of orientations per scale (Nor = 4 or Nor = 6)
% Nb  = spatial resolution of each subband
%
% dimension of vC=Nsc*Nor*Nb^2
%
% vC are the global features

if nargin==1
    Nsc=4; 
end
if nargin<3
    Nor = 4;
end
if nargin<4
    Nb = 4;
end

switch Nor
    case 4
        pyrFilters = 'sp3Filters'; 
    case 6
        pyrFilters = 'sp5Filters';
end


% LOCAL FEATURES:
c=size(img, 3);
vL=[]; vLind=[];
if nargout<3
    for n=1:c
        [vL(:,n) vLind(:,:,n)] = buildSpyr(double(img(:,:,n)), Nsc, pyrFilters);
    end
else
    vL=[]; vLind=[];
    [vL vLind] = buildSpyr(mean(img,3), Nsc, pyrFilters);
end

% Global features:
if nargout>2
    v = zeros(Nb, Nb, Nsc*Nor);  
    
    for b=1:Nsc*Nor
        x =  pyrBand(vL(:), vLind(:,:), b+1);
        xN = down_sample(abs(x), Nb, Nb)*size(x,1);
        v(:,:,b)=xN;
    end
    vC = v(:);
end
