% Compares the power-exponential distribution with a histogram to show the
% accuracy of the fit:

img = imread('C:\atb\EXPERIMENTS\TopDown\analysis\images\bakery.JPG');
img = imresize(img, .5, 'bilinear');
%img = mean(img,3);
[mIMA,nIMA,p]=size(img)

Nsc = 4;
Nor = 4;

[vL,vLind]=features(img, Nsc, Nor);
l=0;
X = zeros(mIMA*nIMA,p*Nsc*Nor); 
for n=1:size(img,3)
    for b=2:size(vLind,1)-1
        x =  (pyrBand(vL(:,n),vLind(:,:,n),b));
        x = imresize(x, [mIMA,nIMA], 'nearest');
        x = (x - mean(x(:)))/std(x(:));
        l=l+1;
        X(:,l)=x(:);
    end
end


disp('fit power-exponential')
[mu, cY, k] = fitPowerExponential (X, 2000);
%cY = cY+1*eye(size(cY,1))*max(eig(cY));
disp('evaluate saliency')
saliencyMap = powerExponential(X, mu, cY, k); 
saliencyMapLaplace = reshape(saliencyMap, [mIMA nIMA]);

disp('fit gaussian')
[mu, cY] = fitGaussian (X);
%cY = cY+1*eye(size(cY,1))*max(eig(cY));
disp('evaluate saliency')
saliencyMap = powerExponential(X, mu, cY, 2); 
saliencyMapGaussian = reshape(saliencyMap, [mIMA nIMA]);

j = find(saliencyMapGaussian(:)>0);
figure
subplot(131)
imagesc(img)
axis('equal'); axis('tight')
subplot(132)
imagesc(1./(saliencyMapLaplace.^.1+0*min(saliencyMapLaplace(:))))
axis('equal'); axis('tight')
colormap(gray(256))
subplot(133)
imagesc(1./(saliencyMapGaussian+100000000000000^1*min(saliencyMapGaussian(j))))
axis('equal'); axis('tight')
colormap(gray(256))


