function [p, logP] = powerExponential(y, mu, cY, k)
%function p = powerExponential(y, mu, Sigma, k)
% Pdf multivariate power exponential 
%
% y = [Nsamples x dimensions]
%
% Lindsey 1999
% 

% R = size(y,2);
% Nsamples = size(y,1);
% 
% y = y - repmat(mu, Nsamples, 1);
% icY=inv(Sigma);
% if R==1
%     d = y.*icY.*y;
% else
%     xmX=y*icY; d=dot(xmX',y');
% end
% 
% K = R * gamma(R/2) / (pi^(R/2) * sqrt(det(Sigma)));
% Kj = K / gamma(1+R/2/k) / 2^(1+R/2/k);
% 
% p = Kj*exp(-.5*d.^k);
% 

% USING LOGARITHMS:

R = size(y,2);
Nsamples = size(y,1);

y = y - repmat(mu, Nsamples, 1);
icY=inv(cY);
lnKc = log(2)/k +  gammaln((R+2)/(2*k)) - log(R) - gammaln(R/(2*k));

%S = exp(lnKc) * icY;
S = icY;

%Kj = R * gamma(R/2) / (pi^(R/2)) * sqrt(det(S)) / gamma(1+R/(2*k)) / 2^(1+R/(2*k));
lnKj = log(R) + gammaln(R/2) - log(pi)*R/2 + lnKc*R/2 + log(sqrt(det(icY))) - gammaln(1+R/(2*k)) - log(2)*(1+R/(2*k));

if R==1
    d = y.*S.*y;
else
    xmX=y*S; 
    d=dot(xmX',y');
end
logP = lnKj - (.5*d.^k) * exp(lnKc*k);

p = exp(logP);
