% Compares the power-exponential distribution with a histogram to show the
% accuracy of the fit:

img = imread('C:\atb\EXPERIMENTS\TopDown\analysis\images\bakery.JPG');
img = imresize(img, .5, 'bilinear');
img = mean(img,3);
[mIMA,nIMA,p]=size(img)

Nsc = 4;
Nor = 4;

[vL,vLind]=features(img, Nsc, Nor);
l=0;
X = zeros(mIMA*nIMA,p*Nsc*Nor); 
for n=1:size(img,3)
    for b=2:size(vLind,1)-1
        x =  (pyrBand(vL(:,n),vLind(:,:,n),b));
        x = imresize(x, [mIMA,nIMA], 'nearest');
        x = (x - mean(x(:)))/std(x(:));
        l=l+1;
        X(:,l)=x(:);
    end
end


disp('fit power-exponential')
[mu, cY, k] = fitPowerExponential (X(1:32:end,:));
disp('evaluate saliency')
saliencyMap = powerExponential(X, mu, cY, k); 
saliencyMap = reshape(saliencyMap, [mIMA nIMA]);

figure
subplot(121)
imagesc(img)
subplot(122)
imagesc(saliencyMap)
colormap(gray(256))

[mu, cY, k] = fitPowerExponential (X(1:32:end,1));
[hy, y] = hist(X(:,1),40); hy = hy/sum(hy);


p = powerExponential(y', mu, cY, k); 
p = p/sum(p);

figure
plot(y, hy)
hold on
plot(y,p,'r')

[mu, cY, k] = fitPowerExponential (X(:,1:2));

[xx,yy] = meshgrid(linspace(min(min(X(:,1:2)))/5, max(max(X(:,1:2)))/5, 41));
p = powerExponential([xx(:) yy(:)], mu, cY, k); 

p = reshape(p, size(xx));

figure
surfl(p)
colormap(gray(256))


[mu, cY, k] = fitPowerExponential (X(:,[1 2]));
j = find(abs(X(:,2))<.001);
[hy, y] = hist(X(j,1),40); hy = hy/max(hy);
p = powerExponential([y(:) 0*y(:)], mu, cY, k); 
figure
plot(y, hy)
hold on
plot(y,p/max(p),'r')



